%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs            PSG Type    PSG Object         Location in Problem Statement                         Class
%matrix_p_data     data        matrix_p           -entropyr(matrix_p)                                   double
%                                                 linear(matrix_p)
%varibles_p        vars        matrix_p           -entropyr(matrix_p)                                   cell
%                                                 linear(matrix_p)
%matrix_y_data     data        matrix_y           linear(matrix_y)                                      double
%                                                 pCvar(vector_cl,matrix_y)
%varibles_p        vars        matrix_y           linear(matrix_y)                                      cell
%                                                 pCvar(vector_cl,matrix_y)
%                                                 linear(matrix_y2)
%matrix_y2_data    data        matrix_y2          linear(matrix_y2)                                     double
%A1                data        vector_lb          MultiConstraint: >= vector_lb                         double
%alpha1            data        vector_cl          pCvar(vector_cl,matrix_y)                             double
%n_y               data        parameter_numy     problem_approximation_by_parameter_numyy, maximize    double
%EX                data        parameter_ex       Constraint: EX, = parameter_ex                        double
%sigma_sq          data        parameter_sigma    Constraint: sigma_sq, <= parameter_sigma              double
%
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = entropy_maximization_subroutine(matrix_p_data,varibles_p,matrix_y_data,matrix_y2_data,A1,alpha1,n_y,EX,sigma_sq)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_p',matrix_p_data,varibles_p,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_y',matrix_y_data,varibles_p,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_y2',matrix_y2_data,varibles_p,[],[]);
count = count+1;
iargstruc_arr(count) = vector_pack('vector_lb',A1);
count = count+1;
iargstruc_arr(count) = vector_pack('vector_cl',alpha1);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'problem_approximation_by_parameter_numyy, maximize',...
'  -entropyr(matrix_p)',...
'Constraint: EP, == 1',...
'  linear(matrix_p)',...
'Constraint: EX, == parameter_ex',...
'  linear(matrix_y)',...
'Constraint: sigma_sq, <= parameter_sigma',...
'  linear(matrix_y2)',...
'MultiConstraint: >= vector_lb',...
'  pCvar(vector_cl,matrix_y)',...
'Box: >=0',...
'Solver: init_point = 0.01',...
' ');
%Change parameters with their values in problem statement:
problem_statement=strrep(problem_statement,'parameter_sigma',num2str(sigma_sq));
problem_statement=strrep(problem_statement,'parameter_numy',num2str(n_y));
problem_statement=strrep(problem_statement,'parameter_ex',num2str(EX));

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

